## xiphos 3.1.3

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import os, os.path
import intltool


# waf imports
import Utils
import Options
import ccroot


# custom imports
import waffles.misc
import waffles.gnome as gnome

# the following two variables are used by the target "waf dist"
VERSION='3.1.3'
APPNAME='xiphos'
PACKAGE='xiphos'



# these variables are mandatory ('/' are converted automatically)
srcdir = '.'
blddir = 'build'

# dir where waf will search custom (additional) files
_tooldir = './waffles/'

_prefix = '/usr/local'

ROOTDIR_WIN32 = 'C:\msys'

_headers = '''
dlfcn.h
inttypes.h
locale.h
memory.h
stdint.h
stdlib.h
strings.h
string.h
sys/stat.h
sys/types.h
unistd.h
sys/select.h
sys/socket.h
winsock.h
'''.split()

def set_options(opt):


    # options provided by the modules
    #opt.tool_options('g++ gcc gnome intltool glib2')
    opt.tool_options('g++ gcc')

    opt.add_option('--enable-gtkhtml', action='store_true', default=False,
            dest='gtkhtml',
            help='Use gtkhtml instead of gtkmozembed [Default: disabled]')

    opt.add_option('--disable-console',
            action='store_true',
            default=False,
            help='Disable console window in win32 [Default: enabled]',
            dest='no_console')

    opt.add_option('-d', '--debug-level',
		action = 'store',
		default = ccroot.DEBUG_LEVELS.ULTRADEBUG,
		help = "Specify the debugging level ['ultradebug', 'debug', 'release', 'optimized']",
		choices = ['ultradebug', 'debug', 'release', 'optimized'],
		dest = 'debug_level')

    opt.add_option('--strip', action='store_true', default=False,
                    help='Strip resulting binary')

    opt.add_option('--enable-delint', action='store_true', default=False,
            dest='delint',
            help='Use -Wall -Werror[Default: disabled]')


    ### cross compilation from Linux/Unix for win32

    opt.add_option('--target-platform-win32', action='store_true', default=False,
            dest='cross_win32',
            help='Cross-compile for win32 [Default: disabled]')

    # FIXME - handle this option
    #opt.add_option('--rootdir',
		#action = 'store',
		#help = 'Specify path where resides msys. This dir is used for finding libraries and other files',
		#dest = 'rootdir')

    opt.add_option('--pkgconf-libdir',
		action = 'store',
		default = os.path.join(ROOTDIR_WIN32, 'local', 'lib', 'pkgconfig'),
		help = "Specify dir with *.pc files for cross-compilation",
		dest = 'pkg_conf_libdir')

    opt.add_option('--pkgconf-prefix',
		action = 'store',
		default = os.path.join(ROOTDIR_WIN32, 'local'),
		help = "Specify prefix with folders for headers and libraries for cross-compilation",
		dest = 'pkg_conf_prefix')

    opt.add_option('--mozilla-distdir',
		action = 'store',
		default = os.path.join(ROOTDIR_WIN32, 'local'),
		help = "Folder 'dist' in unpacked mozilla devel tarball. Mandatory for win32 compilation",
		dest = 'mozilla_distdir')

    opt.add_option('--disable-dbus',
                   action = 'store_true',
                   default = False,
                   help = "Disable the Xiphos dbus API [Default: enabled]",
                   dest = 'without_dbus')

    opt.add_option('--no-post-install',
                   action = 'store_false',
                   default = True,
                   help = "Disable post-install tasks",
                   dest = 'post_install')

    group = opt.add_option_group ('Localization and documentation', '')
    group.add_option('--helpdir',
		action = 'store',
		default = '${DATAROOTDIR}/gnome/help/${PACKAGE}',
                help = "user documentation [Default: ${DATAROOTDIR}/gnome/help/${PACKAGE}]",
		dest = 'helpdir')
    group.add_option('--disable-help',
            action='store_true',
            default=False,
            help='Disable creating help files',
            dest='disable_help')


def configure(conf):

    env = conf.env
    import Utils
    platform = Utils.detect_platform()
    env['IS_WIN32'] = platform == 'win32'
    env['IS_LINUX'] = platform == 'linux'

    env['IS_CROSS_WIN32'] = Options.options.cross_win32

    # cross-compilation for Windows
    # behave mostly like on windows platform
    if env['IS_CROSS_WIN32']:
        env['IS_WIN32'] = True
        env['IS_LINUX'] = False
        Utils.pprint('CYAN', "Cross-compilation")

    # IS_WIN32 means compiling for win32, not compiling necessary on win32
    if env['IS_WIN32']:
        Utils.pprint('CYAN', "Windows detected")
    elif env['IS_LINUX']:
        Utils.pprint('CYAN', "Linux detected")

    if not (env['IS_LINUX'] or env['IS_WIN32']):
        Utils.pprint('RED', "Assuming %s is UNIX like platform" % platform)
        env['IS_LINUX'] = True

    ## temporary HACKS for win32
    if env['IS_WIN32']:
        env['PREFIX'] = conf.escpath(os.path.abspath('win32/binaries/Xiphos'))
    ##

    if env['IS_WIN32']:
        env['ROOTDIR'] = ROOTDIR_WIN32
    
    conf.check_tool('g++ gcc')
    # cross compiler
    if env['IS_CROSS_WIN32']:
        conf.check_tool('cross_linux_win32', tooldir=_tooldir)

    conf.check_tool('gnu_dirs misc')
    conf.check_tool('intltool') # check for locale.h included

    opt = Options.options
    env['DISABLE_HELP'] = opt.disable_help

    if not opt.disable_help:
        if env['IS_LINUX']:
            conf.check_tool('gnome', tooldir=_tooldir)
        else:
            conf.check_tool('documentation', tooldir=_tooldir) # stuff to create help files

    # DATADIR is defined by intltool in config.h - conflict in win32 (mingw)
    conf.undefine('DATADIR')

    env['POST_INSTALL']=opt.post_install

    if env['IS_WIN32']:
        # tool to link icon with executable
        # use tool modified for cross-compilation support
        env['POST_INSTALL']=False
        conf.check_tool('winres', tooldir=_tooldir)
        # the following line does not work because of a problem with waf
        # conf.check_tool('intltool')
        #env['POCOM'] = conf.find_program('msgfmt')
        #env['INTLTOOL'] = '/usr/local/bin/intltool-merge'
    #else:


    # delint flags
    env['CXXFLAGS_DELINT'] = ['-Werror', '-Wall']
    env['CCFLAGS_DELINT'] = ['-Werror', '-Wall', '-Wmissing-prototypes',
                             '-Wnested-externs', '-Wpointer-arith', '-Wno-sign-compare']

    # gcc compiler debug levels
    # msvc has levels predefined
    if env['CC_NAME'] == 'gcc':
        env['CCFLAGS_SAFE']       = env['CCFLAGS']
        env['CCFLAGS']            = []
        env['CCFLAGS_OPTIMIZED']  = ['-O2']
        env['CCFLAGS_RELEASE']    = ['-O2']
        env['CCFLAGS_DEBUG']      = ['-g', '-DDEBUG']
        env['CCFLAGS_ULTRADEBUG'] = ['-g3', '-O0', '-DDEBUG']

    if env['CXX_NAME'] == 'gcc':
        env['CXXFLAGS_SAFE']       = env['CXXFLAGS']
        env['CXXFLAGS']            = []
        env['CXXFLAGS_OPTIMIZED']  = ['-O2']
        env['CXXFLAGS_RELEASE']    = ['-O2']
        env['CXXFLAGS_DEBUG']      = ['-g', '-DDEBUG', '-ftemplate-depth-25']
        env['CXXFLAGS_ULTRADEBUG'] = ['-g3', '-O0', '-DDEBUG', '-ftemplate-depth-25']
    
    if env['IS_WIN32']:
        ## setup for Winsock on Windows (required for read-aloud)
        conf.check(lib='ws2_32', uselib='WSOCK', mandatory=True)
        conf.check(lib='shell32', uselib='SHELLAPI', mandatory=True)
        # this isn't supposed to be necessary
        env['LINKFLAGS'] = ['-lws2_32']
    
    ### cmd line options

    opt = Options.options
    dfn = conf.define
    env = conf.env


    if env['IS_CROSS_WIN32']:
        # allows to use linux pkg-config for cross-compilation
        os.environ['PKG_CONFIG_LIBDIR'] = opt.pkg_conf_libdir
        env['PKG_CONFIG_PREFIX'] = opt.pkg_conf_prefix

    # mozilla distdir mandatory for win32 for using libxul
    if env['IS_WIN32']:
        if opt.mozilla_distdir:
            env['MOZILLA_DISTDIR'] = opt.mozilla_distdir
        else:
            env['MOZILLA_DISTDIR'] = '%s/../..' % env['PKG_CONFIG_LIBDIR']

    # appropriate cflags
    env.append_value('CXXFLAGS', env['CXXFLAGS_%s' % opt.debug_level.upper()])
    env.append_value('CCFLAGS', env['CCFLAGS_%s' % opt.debug_level.upper()])

    if env['IS_WIN32']:
        dfn('WIN32', 1)

    if opt.delint:
        env.append_value('CXXFLAGS', env['CXXFLAGS_DELINT'])
        env.append_value('CCFLAGS', env['CCFLAGS_DELINT'])

    # gtkhtml
    if opt.gtkhtml:
        env['ENABLE_GTKHTML'] = True
        dfn('GTKHTML', 1)

    # disable console window in win32
    if opt.no_console and env['IS_WIN32']:
        env.append_value('LINKFLAGS', '-mwindows')


    # strip xiphos binary
    if env['IS_CROSS_WIN32']:
        env['STRIP'] = conf.find_program('i686-mingw32-strip', mandatory=True)
    else:
        env['STRIP'] = conf.find_program('strip', mandatory=True)

    if (not env['IS_LINUX']) and (opt.debug_level in ['release','optimized']):
        env['TO_STRIP'] = True
    else:
        env['TO_STRIP'] = opt.strip

    if not opt.without_dbus:
        conf.check_pkg('dbus-glib-1', '0.60', True, var='DBUS')
        # we need a modified version of dbus.py for running on windows
        conf.check_tool('dbus', tooldir=_tooldir)
        conf.check_tool('glib2')


    ### App info, paths
    define = conf.define
    sub = Utils.subst_vars

    env['VERSION'] = VERSION
    env['APPNAME'] = APPNAME
    env['PACKAGE'] = PACKAGE
    env['HELPDIR'] = sub(opt.helpdir, env)

    define('VERSION', VERSION)
    define('PACKAGE_VERSION', VERSION)
    define('GETTEXT_PACKAGE', PACKAGE)
    define('PACKAGE', PACKAGE)
    define('PACKAGE_NAME', APPNAME)
    define('PACKAGE_STRING', '%s %s' % (APPNAME, VERSION))
    define('PACKAGE_TARNAME', PACKAGE)

    define('INSTALL_PREFIX', conf.escpath(sub('${PREFIX}/', env)))
    #dfn('LT_OBJDIR', '.libs') - what's the purpose?
    define('PACKAGE_BUGREPORT','http://sourceforge.net/tracker/?group_id=5528&atid=105528' )
    define('PACKAGE_DATA_DIR', conf.escpath(sub('${DATAROOTDIR}/${PACKAGE}', env)))
    define('PACKAGE_DOC_DIR', conf.escpath(env['DOCDIR']))
    define('PACKAGE_HELP_DIR', conf.escpath(sub('${DATAROOTDIR}/gnome/help/${PACKAGE}', env)))
    define('PACKAGE_LOCALE_DIR', conf.escpath(env['LOCALEDIR']))
    define('PACKAGE_MENU_DIR', conf.escpath(sub('${DATAROOTDIR}/applications', env)))
    define('PACKAGE_PIXMAPS_DIR', conf.escpath(sub('${DATAROOTDIR}/pixmaps/${PACKAGE}', env)))
    define('PACKAGE_SOURCE_DIR', conf.escpath(os.path.abspath(srcdir))) # foder where was wscript executed

    # pkg-config
    conf.check_cfg(atleast_pkgconfig_version='0.9.0')

    # GTK+
    #check_pkg(conf, 'gtk+-x11-2.0', '2.0.0', var='LIBGTK_X11_2_0')
    #if not env['HAVE_LIBGTK_X11_2_0']:
    #    check_pkg(conf, 'gtk+-x11-2.0', '2.0.0', True, var='LIBGTK_WIN32_2_0')
    conf.check_pkg('gtk+-2.0', '2.14', True, var='GTK')
    # glade
    conf.check_pkg('libglade-2.0', '2.0.0', var='GLADE')
        
    conf.check_pkg('gmodule-2.0', '2.0.0', True, var='GMODULEEXP')
    conf.check_pkg('glib-2.0', '2.0.0', True, 'GLIB')

    ## gfs
    conf.check_pkg('libgsf-1', '1.14', True, var='GFS')

    #check_pkg(conf, 'libgnomeprintui-2.2', '2.2', True, var='GNOMEPRINTUI')
    #check_pkg(conf, 'libgnomeprint-2.2', '2.2', True, var='GNOMEPRINT')

    ## Other
    conf.check_pkg('libxml-2.0', '2.0.0', True, var='XML')

    conf.check_pkg('gtk+-unix-print-2.0', '2.0.0', var='UPRINT')
    if env['HAVE_UPRINT']:
        dfn('USE_GTKUPRINT', 1)

    ## Sword
    conf.check_pkg('sword', '1.5.11', True, var='SWORD')

    conf.check_pkgver_msg('sword', '1.5.11.99', var='MULTIVERSE',
            msg='Checking for sword multiverse')
    if env['HAVE_MULTIVERSE']:
        dfn('SWORD_MULTIVERSE', 1)


    #here gtkhtml
    conf.check_pkg('libgtkhtml-3.14', version='3.23', mandatory=True, var='GTKHTML')

    if conf.env['HAVE_GTKHTML']:
	conf.define('USE_GTKHTML3_14', 1)

    conf.check_pkg('gtkhtml-editor', mandatory=True)

    ######################
    ### gecko (xulrunner) for html rendering
    # gtkhtml only for editor
    if not env['ENABLE_GTKHTML']:

=== debian/changelog ===
xiphos (3.1.3-3) unstable; urgency=low

  * Fix FTBFS on hppa (Closes: #582904)

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Mon, 24 May 2010 13:21:33 +0000

xiphos (3.1.3-2) unstable; urgency=low

  * Fixing Intrepid->Karmic builds. It was a perl bug.
  * Added debug package
  * Manually adding xulrunner dependency when dh_xulrunner is not available.
  * Lzma compressed debs when version has ~ (e.g. ppa)
  * Source format 3.0 (quilt) official, 1.0 ppas
  * Keeping XDG desktop file & icon in arch package to appear in appinstall-data
  * Cleaned up build-dependencies
  * Rebuild to pick up new gtkhtml dependency (Closes: #582169)

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Sat, 03 Apr 2010 07:52:25 +0000

xiphos (3.1.3-1) unstable; urgency=low

  * New upstream release:
    + Bugfix only
    + Compatible with xulrunner 1.9.2
    + Update translations

  * Revert changes introduced in 3.1.2-1ubuntu1. Thank you Chris Coulson
    for temporary fix.
  * debian/xiphos.1 - spelling mistake
  * waf is now default buildsystem
  * help is now licensed under GPL
  * Bumped standards version no changes required
  * Changed email to @ubuntu.com

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Mon, 22 Mar 2010 18:15:54 +0000

xiphos (3.1.2-1ubuntu1) lucid; urgency=low

  * debian/patches/xul192-workaround.patch:
    - Ensure that we don't load the 1.9.2 GRE if it is installed, as
      1.9.2 makes xiphos unusable at the moment. This is a temporary 
      measure until the new xulrunner behaviour is understood
  * debian/control:
    - Explicitly depend xulrunner-1.9.1
  * debian/rules:
    - Don't call dh_xulrunner to automatically populate the binary depends.
      This is known to be broken in xulrunner-1.9.1 (it adds an incorrectly
      versioned dependency). We add it manually instead

 -- Chris Coulson <chris.coulson@canonical.com>  Fri, 12 Mar 2010 12:12:23 +0000

xiphos (3.1.2-1build1) lucid; urgency=low

  * No source change rebuild against xulrunner-1.9.2 (LP: #536877)

 -- Micah Gersten <micahg@ubuntu.com>  Sun, 28 Feb 2010 05:55:36 -0600

xiphos (3.1.2-1) unstable; urgency=low

  * New Upstream Release
  * Thank you Mike Hommey <glandium@debian.org> for NMU
  * Refreshed patches, Dropped documentation license patch-out
  * Run dh_xulrunner if available
  * Refreshed build-depends (+libgfs +libdbus-glib -libmagick++)
  * Added alternative xulrunner-1.9.1-dev and xulrunner-1.9-dev for 8.04, 8.10.
  * Added omf and icon files
  * Removed all patches
  * Backported PL and HU translations
  * Added waf build system to be anabled in future releases & ppa

 -- Dmitrijs Ledkovs <dmitrij.ledkov@gmail.com>  Wed, 13 Jan 2010 23:27:01 +0000

xiphos (3.1.1-2.1) unstable; urgency=low

  * Non-maintainer upload for transition to xulrunner 1.9.1.
    (Closes: #548682)
  * debian/rules: Use dh_xulrunner
  * debian/control:
    - Build-depend on a xulrunner-dev that provides dh_xulrunner.
    - Build-depend on libglade2-dev. (Closes: #549788)
    - Don't build-depend on gnome-spell (Closes: #549084)
  * debian/patches/gre_version.patch: Tighten the GREVersionRange.
  * debian/patches/series: Added gre_version.patch.
  * Rebuilding will get the proper libgtkhtml-editor0 dependencies.
    (Closes: #550301)
  * Getting proper dependencies from dh_xulrunner, and tightening
    GREVersionRange should avoid segfault at startup. (Closes: #550041)

 -- Mike Hommey <glandium@debian.org>  Sat, 10 Oct 2009 18:49:57 +0200

xiphos (3.1.1-2) unstable; urgency=high

  * debian/control:
    - Re-add "Provides: sword-frontend"
    - Add "Suggests: sword-text"
    - Xiphos depends on source-version xiphos-data (thanks Matthew Talbert)
    - Bumped debhelper version to >= 7.0.50~
    - Bumped standards version to 3.8.3
  
  * debian/README.source:
    - New file. Describing standard quilt
  
 -- Dmitrijs Ledkovs <dmitrij.ledkov@gmail.com>  Mon, 24 Aug 2009 23:32:53 +0000

xiphos (3.1.1-1) unstable; urgency=low

  * New upstream release (bugfix)
  
  * debian/copyright updates:
    - help/* is GFDL and referencing license file as per policy 3.8.2
    - updated copyright holders (Gnomesword -> Xiphos)
  
  * debian/control:
    - Bumped standards version (Changed debian/copyright as above)
    - Updated VCS-Bzr field to point to a working URL
    - Fixed typo in debian/control (Closes: #539190)
    - Updated extended description of xiphos package (Closes: #539880)
    - Significantly improved wording of all descriptions
    - Added Conflicts: xiphos-svn - upstream deb package name for svn builds

 -- Dmitrijs Ledkovs <dmitrij.ledkov@gmail.com>  Wed, 12 Aug 2009 19:21:05 +0000

xiphos (3.1-1) unstable; urgency=low

  * New upstream release. (LP: #331313)
    - Norwegian + Welsh translations;
    - improvements to journal/prayerlist management.
    - many bookmark improvements: multi-verse bookmarks; saving search
    results as bookmarks.
    - better (and fixed) image resize display.
    - vastly improved passage exporter.
    - history management updates and fixes.
    - Fixed crashes sometimes on clicking on words in the text (LP: #379003)
    - Fixed crashes on focus click (LP: #346942)
    - Fixed no easy way to jump to search results (LP: #241577)
    - Fixed dictionaries not functioning (LP: #164152)
  * Added patches:
    - Remove extra GPL license from documentation
    - Remove obsolete files from POTFILES
    - Add generated desktop.in to POTFILES.skip
  * Bumped build-time requirements on sword & gtkhtml
  * Switched to dh7 from cdbs
  * Build Dependecies
    - Add libgtkhtml-editor-dev | gtkhtml3.14 (later for Hardy compatibility)
    - Add xulrunner-dev | libxul-dev (later for Hardy compatibility)
    - Add libcurl4-gnutls-dev, libicu and libcluecene
    - Add version dependency for debhelper (>= 7)
    - Switched to unversioned libmagick++-dev dependency
    - Removed chrpath & cdbs dependency
  * Run-time Dependecies
    - Add libgtkhtml-editor0 | gtkhtml3.14 (for Hardy) (LP: #150425)


=== debian/control ===
Source: xiphos
Build-Depends: quilt,
               debhelper (>= 7.0.50~),
               libsword-dev (>=1.5.11),
               rarian-compat,
               libgtkhtml3.14-dev,
               libgtkhtml-editor-dev | gtkhtml3.14,
               gnome-doc-utils,
               intltool,
               libgtk2.0-dev,
	       libgsf-1-dev,
               libglade2-dev,
	       libdbus-glib-1-dev,
               libxml2-dev,
               xulrunner-dev (>= 1.9.1.3-2) | xulrunner-1.9.1-dev | xulrunner-1.9-dev,
Section: gnome
Priority: optional
Maintainer: CrossWire Packages <pkg-crosswire-devel@lists.alioth.debian.org>
Uploaders: Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>
Standards-Version: 3.8.4
Vcs-Bzr: http://bazaar.launchpad.net/~pkgcrosswire/xiphos/main
Vcs-Browser: http://bazaar.launchpad.net/~pkgcrosswire/xiphos/main/files
Homepage: http://xiphos.org

Package: xiphos
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, xiphos-data (= ${source:Version}), libgtkhtml-editor0 | gtkhtml3.14
Replaces: xiphos-data
Conflicts: xiphos-svn
Provides: sword-frontend
Suggests: sword-text
Description: environment for Bible reading, study, and research
 Xiphos is a Bible study program for the GNOME desktop environment, based on The
 SWORD Project by the CrossWire Bible Society, a framework for developing Bible
 study tools and of associated texts such as commentaries and dictionaries.
 .
 This package provides the main Xiphos program, a digital text reader with
 bookmarks and full-text search. It allows viewing multiple versions of the same
 text, for parallel reading of alternatives or translations. It also supports
 personal verse-specific notes and a rich-text study pad, both of which have
 spell checking and full-text search.
 .
 Xiphos has a built-in facility to browse and install freely-distributed content
 from CrossWire repositories.

Package: xiphos-dbg
Priority: extra
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, xiphos (= ${binary:Version}),
Conflicts: xiphos-svn
Provides: sword-frontend
Suggests: sword-text
Description: debug symbols for Xiphos Bible study software
 Xiphos is a Bible study program for the GNOME desktop environment, based on The
 SWORD Project by the CrossWire Bible Society, a framework for developing Bible
 study tools and of associated texts such as commentaries and dictionaries.
 .
 This package contains debugging symbols that are necessary to procude
 stacktraces of Xiphos.

Package: xiphos-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: xiphos-svn
Suggests: xiphos
Description: data files for Xiphos Bible study software
 Xiphos is a Bible study program for the GNOME desktop environment, based on The
 SWORD Project by the CrossWire Bible Society, a framework for developing Bible
 study tools and of associated texts such as commentaries and dictionaries.
 .
 This package contains the data files that are necessary to use Xiphos.

Package: gnomesword
Architecture: all
Depends: xiphos, ${shlibs:Depends}, ${misc:Depends}
Conflicts: xiphos-svn
Description: transitional package for GnomeSword, now Xiphos
 This is a transitional package and can safely be removed. GnomeSword has been
 renamed to Xiphos; see the "xiphos" package instead.

=== debian/rules ===
#!/usr/bin/make -f
#Ubuntu doesn't have dh_xulrunner yet
xul:=$(shell which dh_xulrunner)
qul:=$(shell which dh_quilt_patch)
ppa:=$(shell sed -n "1s/.*~.*/yes/p" debian/changelog)

ifneq ($(qul),)
args:=quilt
else
include /usr/share/quilt/quilt.make
clean: unpatch
build: $(QUILT_STAMPFN)
endif
ifneq ($(xul),)
args:=$(args),xulrunner
endif
ifneq ($(args),)
with=--with $(args)
endif

%:
	dh $(with) --parallel $@
override_dh_auto_configure:
	./waf configure --nocache --prefix=/usr
override_dh_auto_build:
	./waf build --nocache
override_dh_auto_install:
	./waf install --nocache --destdir=debian/tmp
override_dh_strip:
	dh_strip --dbg-package=xiphos-dbg
override_dh_auto_clean:
	./waf distclean --nocache
override_dh_shlibdeps:
	dh_shlibdeps
# dh_xulrunner replacement when not available
ifeq ($(xul),)
	sed -i "s/\(shlibs:.*\)/\1, $(shell dpkg-query -W xulrunner-1.9* \
	| sed -n "/xulrunner-1.9.*-dev\t./s/\(xulrunner-1.9.*\)-dev\t.*/\1/p")/" \
	debian/xiphos.substvars
endif
override_dh_clean:
	dh_clean
	rm -rf .waf*
	rm -rf waffles/*.pyc
ifeq ($(ppa),)
	echo "3.0 (quilt)" > debian/source/format
else
	echo "1.0" > debian/source/format
endif


# build lzma compressed debs on Launchpad ;-)
override_dh_builddeb:
ifeq ($(ppa),)
	dh_builddeb
else
	dh_builddeb -- -Zlzma
endif

## xiphos 3.1.4

=== wscript ===
--- 
+++ 
@@ -3,36 +3,36 @@
 
 import os, os.path
 import intltool
-
-
-# waf imports
+import string
 import Utils
 import Options
 import ccroot
-
-
-# custom imports
+import preproc
+preproc.go_absolute=1
+preproc.strict_quotes=0
+
 import waffles.misc
 import waffles.gnome as gnome
 
-# the following two variables are used by the target "waf dist"
-VERSION='3.1.3'
+bzrrevno = '$CurRevno$'
+bzrrevid = '$CurRevid$'
+
+VERSION='3.1.4'
+
+if VERSION.find('dev') != -1 and len(bzrrevno.split()) > 1:
+        VERSION = '+'.join((VERSION,
+                            'bzr' + bzrrevno.split()[1]))
+        if bzrrevid.split()[1].find('svn') != -1:
+                VERSION = '+'.join((VERSION,
+                                    'svn' + bzrrevid.split()[1].split(':')[-1]))
+
 APPNAME='xiphos'
 PACKAGE='xiphos'
-
-
-
-# these variables are mandatory ('/' are converted automatically)
 srcdir = '.'
 blddir = 'build'
 
-# dir where waf will search custom (additional) files
 _tooldir = './waffles/'
-
-_prefix = '/usr/local'
-
 ROOTDIR_WIN32 = 'C:\msys'
-
 _headers = '''
 dlfcn.h
 inttypes.h
@@ -49,12 +49,8 @@
 sys/socket.h
 winsock.h
 '''.split()
-
 def set_options(opt):
 
-
-    # options provided by the modules
-    #opt.tool_options('g++ gcc gnome intltool glib2')
     opt.tool_options('g++ gcc')
 
     opt.add_option('--enable-gtkhtml', action='store_true', default=False,
@@ -165,20 +161,20 @@
         env['IS_LINUX'] = True
 
     ## temporary HACKS for win32
-    if env['IS_WIN32']:
-        env['PREFIX'] = conf.escpath(os.path.abspath('win32/binaries/Xiphos'))
-    ##
+    #if env['IS_WIN32']:
+    #    env['PREFIX'] = conf.escpath(os.path.abspath('win32/binaries/Xiphos'))
 
     if env['IS_WIN32']:
         env['ROOTDIR'] = ROOTDIR_WIN32
-    
+
+    conf.check_tool('nothreads', tooldir=_tooldir)
     conf.check_tool('g++ gcc')
     # cross compiler
     if env['IS_CROSS_WIN32']:
         conf.check_tool('cross_linux_win32', tooldir=_tooldir)
-
+  
     conf.check_tool('gnu_dirs misc')
-    conf.check_tool('intltool') # check for locale.h included
+    conf.check_tool('intltool')
 
     opt = Options.options
     env['DISABLE_HELP'] = opt.disable_help
@@ -243,10 +239,10 @@
     env = conf.env
 
 
-    if env['IS_CROSS_WIN32']:
+    #if env['IS_CROSS_WIN32']:
         # allows to use linux pkg-config for cross-compilation
-        os.environ['PKG_CONFIG_LIBDIR'] = opt.pkg_conf_libdir
-        env['PKG_CONFIG_PREFIX'] = opt.pkg_conf_prefix
+        #os.environ['PKG_CONFIG_LIBDIR'] = opt.pkg_conf_libdir
+        #env['PKG_CONFIG_PREFIX'] = opt.pkg_conf_prefix
 
     # mozilla distdir mandatory for win32 for using libxul
     if env['IS_WIN32']:
@@ -255,16 +251,8 @@
         else:
             env['MOZILLA_DISTDIR'] = '%s/../..' % env['PKG_CONFIG_LIBDIR']
 
-    # appropriate cflags
-    env.append_value('CXXFLAGS', env['CXXFLAGS_%s' % opt.debug_level.upper()])
-    env.append_value('CCFLAGS', env['CCFLAGS_%s' % opt.debug_level.upper()])
-
     if env['IS_WIN32']:
         dfn('WIN32', 1)
-
-    if opt.delint:
-        env.append_value('CXXFLAGS', env['CXXFLAGS_DELINT'])
-        env.append_value('CCFLAGS', env['CCFLAGS_DELINT'])
 
     # gtkhtml
     if opt.gtkhtml:
@@ -278,7 +266,7 @@
 
     # strip xiphos binary
     if env['IS_CROSS_WIN32']:
-        env['STRIP'] = conf.find_program('i686-mingw32-strip', mandatory=True)
+        env['STRIP'] = conf.find_program('i686-pc-mingw32-strip', mandatory=True)
     else:
         env['STRIP'] = conf.find_program('strip', mandatory=True)
 
@@ -292,7 +280,6 @@
         # we need a modified version of dbus.py for running on windows
         conf.check_tool('dbus', tooldir=_tooldir)
         conf.check_tool('glib2')
-
 
     ### App info, paths
     define = conf.define
@@ -322,49 +309,57 @@
     define('PACKAGE_PIXMAPS_DIR', conf.escpath(sub('${DATAROOTDIR}/pixmaps/${PACKAGE}', env)))
     define('PACKAGE_SOURCE_DIR', conf.escpath(os.path.abspath(srcdir))) # foder where was wscript executed
 
-    # pkg-config
+
+    if conf.check_cfg(modversion='gtkhtml-editor-3.14',
+                      msg='Is post GNOME3 gtkhtml-editor available?',
+                      okmsg='Deffinatly',
+                      errmsg='Probably, not'
+                      ):
+            editor='"gtkhtml-editor-3.14"'
+    else:
+            editor='"gtkhtml-editor"'
+
+    common_libs = string.join(
+    [editor] + '''
+    "gtk+-2.0 >= 2.14"
+    "libglade-2.0"
+    "gmodule-2.0"
+    "glib-2.0"
+    "libgsf-1 >= 1.14"
+    "libxml-2.0"
+    "libgtkhtml-3.14 >= 3.23"
+    --cflags --libs'''
+    .split()," ")
+
     conf.check_cfg(atleast_pkgconfig_version='0.9.0')
-
-    # GTK+
-    #check_pkg(conf, 'gtk+-x11-2.0', '2.0.0', var='LIBGTK_X11_2_0')
-    #if not env['HAVE_LIBGTK_X11_2_0']:
-    #    check_pkg(conf, 'gtk+-x11-2.0', '2.0.0', True, var='LIBGTK_WIN32_2_0')
-    conf.check_pkg('gtk+-2.0', '2.14', True, var='GTK')
-    # glade
-    conf.check_pkg('libglade-2.0', '2.0.0', var='GLADE')
-        
-    conf.check_pkg('gmodule-2.0', '2.0.0', True, var='GMODULEEXP')
-    conf.check_pkg('glib-2.0', '2.0.0', True, 'GLIB')
-
-    ## gfs
-    conf.check_pkg('libgsf-1', '1.14', True, var='GFS')
-
-    #check_pkg(conf, 'libgnomeprintui-2.2', '2.2', True, var='GNOMEPRINTUI')
-    #check_pkg(conf, 'libgnomeprint-2.2', '2.2', True, var='GNOMEPRINT')
-
-    ## Other
-    conf.check_pkg('libxml-2.0', '2.0.0', True, var='XML')
-
-    conf.check_pkg('gtk+-unix-print-2.0', '2.0.0', var='UPRINT')
-    if env['HAVE_UPRINT']:
-        dfn('USE_GTKUPRINT', 1)
-
-    ## Sword
-    conf.check_pkg('sword', '1.5.11', True, var='SWORD')
-
-    conf.check_pkgver_msg('sword', '1.5.11.99', var='MULTIVERSE',
-            msg='Checking for sword multiverse')
-    if env['HAVE_MULTIVERSE']:
-        dfn('SWORD_MULTIVERSE', 1)
-
-
-    #here gtkhtml
-    conf.check_pkg('libgtkhtml-3.14', version='3.23', mandatory=True, var='GTKHTML')
-
-    if conf.env['HAVE_GTKHTML']:
-	conf.define('USE_GTKHTML3_14', 1)
-
-    conf.check_pkg('gtkhtml-editor', mandatory=True)
+    conf.check_cfg(msg="Checking for GNOME related libs",
+                   package='',
+                   args=common_libs,
+                   uselib_store='GNOME',
+                   mandatory=True)
+
+    env.append_value('ALL_LIBS', 'GNOME')
+
+    conf.check_cfg(package="gtk+-unix-print-2.0",
+                   uselib_stor='GTKUPRINT')
+
+    env.append_value('ALL_LIBS', 'GTKUPRINT')
+
+    conf.check_cfg(package='sword',
+                   args='"sword >= 1.6.1" --cflags --libs',
+                   uselib_store='SWORD',
+                   mandatory=True)
+    env.append_value('ALL_LIBS', 'SWORD')
+
+    conf.check_cfg(package="gtk+-2.0",
+                   atleast_version = "2.16",
+                   uselib_store="GTK_216")
+    conf.check_cfg(package="gtk+-2.0",
+                   atleast_version = "2.18",
+                   uselib_store="GTK_218")
+    conf.check_cfg(package="gtk+-2.0",
+                   atleast_version = "2.20",
+                   uselib_store="GTK_220")
 
     ######################
     ### gecko (xulrunner) for html rendering

=== debian/changelog ===
xiphos (3.1.4-2ubuntu1) natty; urgency=low

  * Fix LP: #761715 - xiphos will stop working after the Firefox 4.0.1
    release. We just hard-code the min/max Gecko versions for now rather
    than trying to figure them out dynamically at build time. The existing
    method of doing that doesn't seem to handle all combinations of Gecko
    versions and also currently makes it FTBFS
    - update debian/patches/xul-2.0.patch

 -- Chris Coulson <chris.coulson@canonical.com>  Fri, 15 Apr 2011 16:39:17 +0100

xiphos (3.1.4-2) unstable; urgency=low

  [ Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com ]
  * Release to unstable
  * Simplify and reduce logic in debian/rules.
  * Drop gnomesword package now that squeeze is released
  * Add dependency (renamed) libgtkhtml-editor-3.14-dev (Closes: #613971)

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Mon, 29 Nov 2010 22:58:32 +0000

xiphos (3.1.4-1) experimental; urgency=low

  [ Jonathan Marsden ]
  * New upstream release 3.1.4
  * Removed debian/patch/* since the one patch was included upstream.
  * Bumped Standards-Version to 3.9.1 (no changes required).
  * debian/README.Debian: Corrected spelling and reworded for clarity.
  * debian/control: Add Jonathan Marsden back into Uploaders.

  [ Dmitrijs Ledkovs ]
  * Added local options dpkg-source to unapply patches and fail on
    upstream source changes (ignoring false positives).
  * Added bzr-builddeb hook to generate source-format before build. If you
    are not using bzr-builddeb, you must run "./debian/rules clean" before
    building.
  * patches/xul-2.0.patch: bump UPPER_RANGE to allow running against xul20.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Thu, 25 Nov 2010 21:26:48 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: xiphos
-Build-Depends: quilt,
+Build-Depends: quilt (>= 0.46.7~),
                debhelper (>= 7.0.50~),
                libsword-dev (>=1.5.11),
                rarian-compat,
                libgtkhtml3.14-dev,
-               libgtkhtml-editor-dev | gtkhtml3.14,
+               libgtkhtml-editor-3.14-dev | libgtkhtml-editor-dev | gtkhtml3.14,
                gnome-doc-utils,
                intltool,
                libgtk2.0-dev,
@@ -15,16 +15,17 @@
                xulrunner-dev (>= 1.9.1.3-2) | xulrunner-1.9.1-dev | xulrunner-1.9-dev,
 Section: gnome
 Priority: optional
-Maintainer: CrossWire Packages <pkg-crosswire-devel@lists.alioth.debian.org>
-Uploaders: Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>
-Standards-Version: 3.8.4
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: CrossWire Packages <pkg-crosswire-devel@lists.alioth.debian.org>
+Uploaders: Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>, Jonathan Marsden <jmarsden@fastmail.fm>
+Standards-Version: 3.9.1
 Vcs-Bzr: http://bazaar.launchpad.net/~pkgcrosswire/xiphos/main
 Vcs-Browser: http://bazaar.launchpad.net/~pkgcrosswire/xiphos/main/files
 Homepage: http://xiphos.org
 
 Package: xiphos
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, xiphos-data (= ${source:Version}), libgtkhtml-editor0 | gtkhtml3.14
+Depends: ${shlibs:Depends}, ${misc:Depends}, xiphos-data (= ${source:Version}), libgtkhtml-editor-3.14-0 | libgtkhtml-editor0 | gtkhtml3.14
 Replaces: xiphos-data
 Conflicts: xiphos-svn
 Provides: sword-frontend
@@ -70,11 +71,3 @@
  study tools and of associated texts such as commentaries and dictionaries.
  .
  This package contains the data files that are necessary to use Xiphos.
-
-Package: gnomesword
-Architecture: all
-Depends: xiphos, ${shlibs:Depends}, ${misc:Depends}
-Conflicts: xiphos-svn
-Description: transitional package for GnomeSword, now Xiphos
- This is a transitional package and can safely be removed. GnomeSword has been
- renamed to Xiphos; see the "xiphos" package instead.

=== debian/rules ===
#!/usr/bin/make -f
#Ubuntu doesn't have dh_xulrunner yet
xul:=$(shell which dh_xulrunner)
ppa:=$(shell sed -n "1s/.*~.*/yes/p" debian/changelog)
daily:=$(shell sed -n "1s/.*2010.*-.*/yes/p" debian/changelog)
# Yes, the next variable name and value are the same
,:=,

%:
	dh $@ --with quilt$(if $(xul),$(,)xulrunner)
override_dh_auto_configure:
	./waf configure --nocache --prefix=/usr
override_dh_auto_build:
	./waf build --nocache
override_dh_auto_install:
	./waf install --nocache --destdir=debian/tmp
override_dh_strip:
	dh_strip --dbg-package=xiphos-dbg
override_dh_auto_clean:
	./waf distclean --nocache
override_dh_shlibdeps:
	dh_shlibdeps
# dh_xulrunner replacement when not available
ifeq ($(xul),)
	sed -i "s/\(shlibs:.*\)/\1, $(shell dpkg-query -W xulrunner-1.9* \
	| sed -n "/xulrunner-1.9.*-dev\t./s/\(xulrunner-1.9.*\)-dev\t.*/\1/p")/" \
	debian/xiphos.substvars
endif
override_dh_clean:
	echo $(if $(ppa),"1.0","3.0 (quilt)") > debian/source/format
	$(if $(daily),cp debian/patches/daily.series debian/patches/series)
	dh_clean
	rm -rf .waf*
	rm -rf waffles/*.pyc

override_dh_builddeb:
	dh_builddeb $(if $(ppa),-- -Zlzma)

=== debian/watch ===
version=3
http://sf.net/gnomesword/xiphos-(.+)\.tar\.gz
